import es,usermsg,cfglib,gamethread,random

import psyco
psyco.full()

info = es.AddonInfo()
info['name'] = "Advanced Wave Spawn"
info['basename'] = "spawnwave"
info['version'] = "1.5"
info['authors'] = "Shidobu"
info['url'] = "http://www.sddcommunity.com"
info['description'] = "Advanced set of tools for respawning."

config = cfglib.AddonCFG(es.getAddonPath("spawnwave") + "/spawnwave_config.cfg")
config.text("*****************************")
config.text("*****Advanced Wave Spawn*****")
config.text("***********Config************")
config.text("*****************************")
config.text(" ")
config.text(" ")
config.text("***************************")
config.text("**Enable/Disable Settings**")
config.text("***************************")
ws_roundmsg = config.cvar("ws_roundmsg",1,"Enable/Disable telling every player at round start that wave spawn is enabled.")
ws_tell = config.cvar("ws_tell",1,"Enable/Disable telling the player that the player is going to respawn in a form of a count down.")
ws_respawn = config.cvar("ws_respawn",1,"Enable/Disable respawning.")
ws_showplayers = config.cvar("ws_showplayers",1,"Enable/Disable showing the players how many players are alive on each team.")
ws_showplayers_msg_enabled = config.cvar("ws_showplayers_msg_enabled",1,"Enable/Disable showing a msg to all players how many players there are alive on each team")
ws_showplayers_hostname_enabled = config.cvar("ws_showplayers_hostname_enabled",1,"Enable/Disable Displaying alive players in your server name.")
ws_restrict = config.cvar("ws_restrict",1,"Enable/Disable the restrictions of respawning.")
config.text(" ")
config.text(" ")
config.text("***************************")
config.text("***Restrictions Settings***")
config.text("***************************")
ws_restrict_mapfilter = config.cvar("ws_restrict_mapfilter","<0>","Set what maps you do not want ASW active on.\n// Format: <mapname><mapname>\n// Example: ws_restrict_mapfilter <aim_ag_texture2><de_dust2>")
ws_restrict_team = config.cvar("ws_restrict_team","0","Set to 1 if you don't want the selected teams to get ASW. <2 = T/3 = CT>\n// Example: ws_restrict_team 3 or ws_restrict_team 2 or both with a comma.")
config.text(" ")
config.text(" ")
config.text("***************************")
config.text("***Show Players Settings***")
config.text("***************************")
ws_showplayers_msg_type = config.cvar("ws_showplayers_msg_type","hudhint","What type of msg do you want it to be? <hudhint/centermsg>")
ws_showplayers_hostname = config.cvar("ws_showplayers_hostname","[SDD] Script Testing -www.sddcommunity.com- CTs:%s|Ts:%s","Set the wanted name for your server.\n// Note: The first %s is the alive CT count and the second %s is the alive T count.")
config.text(" ")
config.text(" ")
config.text("**************************")
config.text("*****Respawn Settings*****")
config.text("**************************")
ws_tell_type = config.cvar("ws_tell_type","centermsg","What should the count down be? <hudhint/centermsg>")
ws_time_type = config.cvar("ws_time_type","set","How do you want the time to respawn be? <set/random>\n// Note: When using the random setting ws_time/ws_ct_time/ws_t_time are the minimum settings.")
ws_time_mode = config.cvar("ws_time_mode","normal","How do you want the time to respawn be? <normal/team>\n// Normal = It will use the time settings from ws_time and ws_time_max.\n// Team = It will use the time settings from ws_time_ct/ws_time_ct_max and ws_time_t/ws_time_t_max.")
ws_time = config.cvar("ws_time",2,"How long you want the until the player respawns.")
ws_time_max = config.cvar("ws_time_max",5,"The max time you want the wait to be for players.")
ws_ct_time = config.cvar("ws_ct_time",2,"How long you want until the ct player respawns.")
ws_ct_time_max = config.cvar("ws_ct_time_max",5,"The max time you want the wait to be for ct players.")
ws_t_time = config.cvar("ws_ct_time",2,"How long you want until the t player respawns.")
ws_t_time_max = config.cvar("ws_t_time_max",5,"The max time you want the wait to be for t players.")
config.text(" ")
config.text(" ")
config.text("*****************************")
config.text("*****Advanced Wave Spawn*****")
config.text("********End of Config********")
config.text("*****************************")
config.write()

global ws_map
ws_map = "<%s>"%es.ServerVar("eventscripts_currentmap")

es.set("ws_version",info.version,info.description)
es.makepublic("ws_version")

def es_map_start(ev):
	global ws_check
	ws_check = 0

def round_start(ev):
	global ws_check
	ws_check = 1
	if ws_showplayers == 1:
		ws_enabled = 1
		if ws_restrict == 1:
			if ws_map in str(ws_restrict_mapfilter):
				ws_enabled = 0
		if ws_enabled == 1:
			ShowPlayers()
	if ws_roundmsg == 1:
		ws_enabled = 1
		if ws_restrict == 1:
			if ws_map in str(ws_restrict_mapfilter):
				ws_enabled = 0
		if ws_enabled == 1:
			es.msg("#multi","\x05[Wave Spawn] #greenAdvanced Wave Spawn #lightgreenby #greenShidobu #lightgreenis active on this server.")

def round_end(ev):
	global ws_check
	ws_check = 0

def player_death(ev):
	if ws_respawn == 1:
		team = str(ev["es_userteam"])
		ws_enabled = 1
		if ws_restrict == 1:
			if ws_map in str(ws_restrict_mapfilter) or team in str(ws_restrict_team):
				ws_enabled = 0
		if ws_enabled == 1:
			if ws_time_type == "random":
				if ws_time_mode == "normal":
					ws_tmp_time = random.randint(ws_time,ws_time_max)
					WaveSpawn(ev["userid"],ws_tmp_time)
				elif ws_time_mode == "team":
					if team == 2:
						ws_tmp_time = random.randint(ws_t_time,ws_t_time_max)
						WaveSpawn(ev["userid"],ws_tmp_time)
					if team == 3:
						ws_tmp_time = random.randint(ws_ct_time,ws_ct_time_max)
						WaveSpawn(ev["userid"],ws_tmp_time)
			elif ws_time_type == "set":
				if ws_time_mode == "normal":
					WaveSpawn(ev["userid"],ws_time)
				elif ws_time_mode == "team":
					if team == 2:
						WaveSpawn(ev["userid"],ws_t_time)
					if team == 3:
						WaveSpawn(ev["userid"],ws_ct_time)

def WaveSpawn(userid,time):
	if ws_check == 1 and ws_respawn == 1:
		if es.getplayerprop(userid,"CCSPlayer.baseclass.pl.deadflag") == 1:
			time -= 1
			if ws_tell == 1:
				if ws_tell_type == "hudhint": usermsg.hudhint(userid,"[Wave Spawn] You will respawn in %s seconds."%time)
				if ws_tell_type == "centermsg": es.centertell(userid,"[Wave Spawn] You will respawn in %s seconds."%time)
			if time > 0: gamethread.delayed(1,WaveSpawn,(userid,time))
			if time == 0: Respawn_Func(userid)

def Respawn_Func(userid):
	es.setplayerprop(userid,"CCSPlayer.m_iPlayerState",0)
	es.setplayerprop(userid,"CCSPlayer.baseclass.m_lifeState",512)
	es.spawnplayer(userid)

def ShowPlayers():
	if ws_check == 1 and ws_showplayers == 1:
		if ws_showplayers == 1:
			tt = es.getplayercount()
			if tt > 0:
				c = es.getlivingplayercount(3)
				t = es.getlivingplayercount(2)
				if ws_showplayers_msg_enabled == 1:
					playerlist = es.getUseridList()
					for player in playerlist:
						if ws_showplayers_msg_type == "centermsg":
							es.centertell(player,"[Wave Spawn] CTs:%s|Ts:%s"%(c,t))
						if ws_showplayers_msg_type == "hudhint":
							usermsg.hudhint(player,"[Wave Spawn] CTs:%s|Ts:%s"%(c,t))
				if ws_showplayers_hostname_enabled == 1:
					ws_tmp = str(ws_showplayers_hostname)%(c,t)
					es.ServerVar("hostname").set(ws_tmp)
			gamethread.delayed(1,ShowPlayers,())